#include <malloc.h>
#include <string.h>
#include "ArrayList.h"

void initXRList(XrArrayList *list, jint capacity, size_t blkSize) {
  list->used = 0;
  list->capacity = capacity;

  if(capacity != 0) {
    list->elements = calloc(capacity, blkSize);
  }else {
    list->elements = NULL;
  }
}

void* getNewXR(XrArrayList *list, size_t blkSize) {
  if((list->used+1) >= list->capacity) {
    int newCapacity = list->capacity*2 + 10;
    if(list->capacity > 0) {
      list->elements = realloc(list->elements, newCapacity * blkSize);
    }else {
      list->elements = calloc(newCapacity, blkSize);
    }
    list->capacity = newCapacity;
  }

  return list->elements + (list->used++ * blkSize);
}

void clearXRList(XrArrayList *list) {
  list->used = 0;
}

